/*
** Telephone v1.1
**
** A WWW telephone book
**
** Copyright (c) 25.3.94 by Andreas Ley <ley@rz.uni-karlsruhe.de>
**
** Permission to use, copy, modify, and distribute this software for any
** purpose and without fee is hereby granted, provided that the above
** copyright notice appears in all copies. This software is provided "as is"
** and without any express or implied warranties.
**
** This program has been tested on a HP9000/720 with HP-UX A.08.07
** In this environment, neither lint -u nor gcc -Wall produce any messages.
** If you encounter any errors or need to make any changes to port it
** to another platform, please contact me.
**
** Version history
**
** Version 1.1 - 6.4.94
**	added access control
**	added umlaut mapping
**
** Version 1.0 - 25.3.94
**	Initial version
*/

char header[]="telephone v1.1\n(c) 1994 by Andreas Ley\n";

/* General definitions */

#define	MASTER	"webmaster@rz.uni-karlsruhe.de"
#define	REFERENCE	"<A HREF=\"/~Andreas.Ley/\"><EM>Andreas Ley</EM></A>"

/* File locations */

#define	ROOT	"/usr/local/etc/httpd/lib/telephone"
#define	ACCESS	".access"

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <regex.h>
#include "telephone_german.h"

#ifdef NEEDSTRERROR
extern int	sys_nerr;
extern char	*sys_errlist[];
#define	strerror(errno)	((errno)>=sys_nerr?"Undefined error":sys_errlist[errno])
#endif /* NEEDSTRERROR */

#define	FALSE	0		/* This is the naked Truth */
#define	TRUE	1		/* and this is the Light */


/* Functions from wildmat.c */

extern int wildmat();

/* Global variables */

char	root[]=ROOT;
char	master[]=MASTER;
char	*script_name;
char	*path_info;

char	*entry[1024];
size_t	max;

char	*iso2din[256] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "\"", "#", "$", "%", "&", "'", 
	"(", ")", "*", "+", ",", "-", ".", "/", 
	"0", "1", "2", "3", "4", "5", "6", "7", 
	"8", "9", ":", ";", "<", "=", ">", "?", 
	"@", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "[", "\\", "]", "^", "_", 
	"`", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "{", "|", "}", "~", NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "c", "l", "c", "y", "|", "#", 
	NULL, "c", "a", "<", "-", "-", "r", "_", 
	"o", "+", "2", "3", NULL, "u", "p", ".", 
	NULL, "1", "o", ">", "1/4", "1/2", "3/4", "?", 
	"a", "a", "a", "a", "ae", "a", "ae", "c", 
	"e", "e", "e", "e", "i", "i", "i", "i", 
	"d", "n", "o", "o", "o", "o", "oe", "x", 
	"o", "u", "u", "u", "ue", "y", "p", "ss", 
	"a", "a", "a", "a", "ae", "a", "ae", "c", 
	"e", "e", "e", "e", "i", "i", "i", "i", 
	"d", "n", "o", "o", "o", "o", "oe", "/", 
	"o", "u", "u", "u", "ue", "y", "p", "y",
	};

char *iso2html[256]= {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, "\t", "\n", NULL, NULL, "\r", NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!", "\"", "#", "$", "%", "&amp;", "'", 
	"(", ")", "*", "+", ",", "-", ".", "/", 
	"0", "1", "2", "3", "4", "5", "6", "7", 
	"8", "9", ":", ";", "&lt;", "=", "&gt;", "?", 
	"@", "A", "B", "C", "D", "E", "F", "G", 
	"H", "I", "J", "K", "L", "M", "N", "O", 
	"P", "Q", "R", "S", "T", "U", "V", "W", 
	"X", "Y", "Z", "[", "\\", "]", "^", "_", 
	"`", "a", "b", "c", "d", "e", "f", "g", 
	"h", "i", "j", "k", "l", "m", "n", "o", 
	"p", "q", "r", "s", "t", "u", "v", "w", 
	"x", "y", "z", "{", "|", "}", "~", " ", 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	" ", "!`", "cents", "pound", "(currency)", "yen", "|", "(sect)", 
	"\"", "(C)", "na.", "&lt;&lt;", "(neg)", "-", "(R)", "=", 
	"^o", "+-", "^2", "^3", "'", "mu", "(par)", "*", 
	",", "^1", "no.", "&gt;&gt;", "1/4", "1/2", "3/4", "?`", 
	"&Agrave;", "&Aacute;", "&Acirc;", "&Atilde;", "&Auml;", "&Aring;", "&AElig;", "&Ccedil;", 
	"&Egrave;", "&Eacute;", "&Ecirc;", "&Euml;", "&Igrave;", "&Iacute;", "&Icirc;", "&Iuml;", 
	"&ETH;", "&Ntilde;", "&Ograve;", "&Oacute;", "&Ocirc;", "&Otilde;", "&Ouml;", "x", 
	"&Oslash;", "&Ugrave;", "&Uacute;", "&Ucirc;", "&Uuml;", "&Yacute;", "&THORN;", "&szlig;", 
	"&agrave;", "&aacute;", "&acirc;", "&atilde;", "&auml;", "&aring;", "&aelig;", "&ccedil;", 
	"&egrave;", "&eacute;", "&ecirc;", "&euml;", "&igrave;", "&iacute;", "&icirc;", "&iuml;", 
	"&eth;", "&ntilde;", "&ograve;", "&oacute;", "&ocirc;", "&otilde;", "&ouml;", "/", 
	"&oslash;", "&ugrave;", "&uacute;", "&ucirc;", "&uuml;", "&yacute;", "&thorn;", "&yuml;", 
	};


/* Prints header of a HTML-Request */
void show_header(char *subtitle, char *description, int prefix, int index)
{
	(void)printf("Content-type: text/html\n\n");
	(void)printf("<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n");
	(void)printf("<HTML>\n");
	(void)printf("<HEAD>\n");
	(void)printf("<TITLE>%s%s%s</TITLE>\n",TITLE,subtitle?" - ":"",subtitle?subtitle:"");
	(void)printf("<LINK REV=\"made\" HREF=\"mailto:%s\">\n",MASTER);
	(void)printf("</HEAD>\n");
	(void)printf("<BODY>\n");
	(void)printf("<H1>%s</H1>\n",TITLE);
	if (prefix)
		(void)printf("%s<P>\n",PREFIX);
	if (index) {
		(void)printf("%s\n",HEADER);
		(void)printf("<ISINDEX>\n");
	}
	if (subtitle)
		(void)printf("<H1>%s</H1>\n",subtitle);
	if (description) {
		(void)printf(description,master);
		(void)printf("<P>\n");
	}
}



/* Prints trailer of a HTML-Request */
void show_trailer()
{
	(void)printf("<P><HR>\n");
	(void)printf(DISCLAIMER,master);
	(void)printf("\n%s\n",REFERENCE);
	(void)printf("</BODY>\n");
	(void)printf("</HTML>\n");
}



/* Shows an error page, based on wrong user input */
void show_error(char *error)
{
	show_header(ERROR,error,FALSE,FALSE);
	show_trailer();
	exit(0);
}



/* Shows an error page, based on internal misfunction */
void show_fatal(char *error)
{
	show_header(ERROR,error,FALSE,FALSE);
	(void)printf(ERROR_FATAL,master);
	(void)printf("<P>\n");
	show_trailer();
	exit(0);
}



void stradd(char **dest, char *src)
{
	if (src)
		while (*src)
			*(*dest)++=*src++;
}



char *din(char *src)
{
	static char	buffer[BUFSIZ];
	char		*dest;

	dest=buffer;
	while (*src)
		stradd(&dest,iso2din[(unsigned char)*src++]);
	*dest='\0';
	return(buffer);
}



char *format(char *raw)
{
	static char	buffer[BUFSIZ];
	char		*src,*dest;

	dest=buffer;
	for (src=raw;*src&&*src=='*';src++);
	while (*src&&*src!='\t')
		stradd(&dest,iso2html[(unsigned char)*src++]);
	if (*src++) {
		*dest++=',';
		*dest++=' ';
		while (*src&&*src!='\t')
			stradd(&dest,iso2html[(unsigned char)*src++]);
		if (*src++) {
			*dest++=',';
			*dest++=' ';
			if ('0'<=*src&&*src<='9')
				*dest++='N';
			while (*src&&*src!='\t')
				stradd(&dest,iso2html[(unsigned char)*src++]);
		}
	}
	*dest='\0';
	return(buffer);
}



/* Displays the main menu */
void main_menu()
{
	int	cnt;
	FILE	*src;
	char	title[BUFSIZ],buffer[BUFSIZ];

	show_header(NULL,MAIN_MENU_HEADER,FALSE,TRUE);
	for (cnt=0;cnt<max;cnt++) {
		src=fopen(entry[cnt],"r");
		(void)fgets(title,sizeof(title),src);
		(void)fgets(buffer,sizeof(buffer),src);
		if (feof(src))
			(void)printf("%s<BR>\n",title);
		else
			(void)printf("<A HREF=\"%s/%s\">%s</A><BR>\n",script_name,entry[cnt],title);
		(void)fclose(src);
	}
	show_trailer();
}



/* Process search request */
void search(char *pattern)
{
	int	cnt,line,flag;
	FILE	*src;
	char	title[BUFSIZ],buffer[BUFSIZ];

	flag=FALSE;
	for (cnt=0;cnt<max;cnt++)
		if ((src=fopen(entry[cnt],"r"))) {
			line=0;
			(void)fgets(title,sizeof(title),src);
			if (wildmat(din(title),pattern)) {
				if (!flag) {
					flag=TRUE;
					show_header(NULL,SEARCH_SUCCESS,TRUE,TRUE);
				}
				(void)printf("<A HREF=\"%s/%s\">%s</A><BR>\n",script_name,entry[cnt],title);
			}
			while(fgets(buffer,sizeof(buffer),src)) {
				line++;
				if (wildmat(din(buffer),pattern)) {
					if (!flag) {
						flag=TRUE;
						show_header(NULL,SEARCH_SUCCESS,TRUE,TRUE);
					}
					(void)printf("<A HREF=\"%s/%s/%d#*\">%s</A> - <A HREF=\"%s/%s\">%s</A><BR>\n",script_name,entry[cnt],line,format(buffer),script_name,entry[cnt],title);
				}
			}
			(void)fclose(src);
		}
	if (!flag) {
		show_header(NULL,SEARCH_FAIL,FALSE,TRUE);
	}
	show_trailer();
}




/* List a table with a reference */
void list(char *fname)
{
	int	line,anchor,cnt;
	FILE	*src;
	char	buffer[BUFSIZ],*ptr;

	anchor=0;
	if ((ptr=strchr(fname,'/'))) {
		*ptr++='\0';
		anchor=atoi(ptr);
	}
	if ((src=fopen(fname,"r"))) {
		line=0;
		(void)fgets(buffer,sizeof(buffer),src);
		show_header(buffer,LIST_HEADER,TRUE,TRUE);
		while(fgets(buffer,sizeof(buffer),src)) {
			line++;
			if (line==anchor)
				(void)printf("<A NAME=\"*\">");
			if (*buffer=='*') {
				for (cnt=0,ptr=buffer;*ptr=='*';cnt++,ptr++);
				cnt+=cnt<4?cnt-1:2;
				(void)printf("<H%d>%s</H%d>\n",cnt,format(buffer),cnt);
			}
			else
				if (line==anchor)
					(void)printf("<STRONG>%s</STRONG><BR>",format(buffer));
				else
					(void)printf("%s<BR>",format(buffer));
			if (line==anchor)
				(void)printf("</A>");
			(void)printf("\n");
		}
		(void)fclose(src);
		show_trailer();
	}
	else
		show_fatal(ERROR_READ);
}



int strptrcmp(const void *s1, const void *s2)
{
	return(strcmp(*(char **)s1,*(char **)s2));
}



void usage(char *image)
{
	(void)fprintf(stderr,"Usage: %s [-h] [-v]\n",image);
	exit(1);
}


int main(int argc, char *argv[])
{
	int		c;
	DIR		*dir;
	struct dirent	*dp;
	char		buffer[BUFSIZ],*remote_host,*query_string,*ptr,*qry;
	FILE		*src;
	int		hasaccess;

	while ((c=getopt(argc,argv,"vh?")) != EOF)
		switch ((char)c) {
		case 'v':
			(void)fprintf(stderr,header);
			exit(0);
		case 'h':
			(void)fprintf(stderr,header);
		case '?':
			usage(argv[0]);
		}

	(void)chdir(root);
	if ((src=fopen(ACCESS,"r"))) {
		remote_host=getenv("REMOTE_HOST");
		hasaccess=FALSE;
		while(!hasaccess&&fgets(buffer,sizeof(buffer),src)) {
			ptr=strchr(buffer,'\0');
			if (ptr[-1]=='\n')
				ptr[-1]='\0';
			if (wildmat(remote_host,buffer))
				hasaccess=TRUE;
		}
		(void)fclose(src);
		if (!hasaccess) {
			(void)sprintf(buffer,NO_ACCESS,remote_host,master);
			show_error(buffer);
		}
	}
	script_name=getenv("SCRIPT_NAME");
	path_info=getenv("PATH_INFO");
	if (*path_info=='/')
		path_info++;
	query_string=getenv("QUERY_STRING");
	unescape_url(query_string);

	ptr=buffer;
	qry=query_string;
	if (qry[0]!='*')
		*ptr++='*';
	for (;*qry;qry++)
		stradd(&ptr,*qry=='+'?"*":iso2din[(unsigned char)*qry]);
	if (ptr>buffer&&ptr[-1]!='*')
		*ptr++='*';
	*ptr='\0';

	if ((dir=opendir("."))) {
		max=0;
		while ((dp=readdir(dir)))
			if (dp->d_name[0]!='.')
				entry[max++]=strdup(dp->d_name);
		(void)closedir(dir);
		if (max)
			qsort((void *)entry,max,sizeof(char *),strptrcmp);
		else
			show_fatal(ERROR_EMPTY);
	}
	else
		show_fatal(ERROR_DIRECTORY);

	if (!strcmp(getenv("REQUEST_METHOD"),"GET"))
		if (*query_string)
			search(buffer);
		else
		if (*path_info)
			list(path_info);
		else
			main_menu();
	else
		show_fatal(ERROR_REQUEST_METHOD);

	return(0);
}
